unit MainUnit; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, LCLProc, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, FileUtil, Buttons, windows;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Image1: TImage;
    Label1: TLabel;
    Panel1: TPanel;
    Timer1: TTimer;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
    function ExtractLzPfad(DatenStr: String): String;
  public
    { public declarations }
  end;

var
  Form1: TForm1; 

implementation

{ TForm1 }
var
  StartPfad, LazarusPfad, LazarusPfad2, BackUpPfad, fpcPfad: String;
  Ti: Integer;
  

function TForm1.ExtractLzPfad(DatenStr: String): String;
var
  ErstPos, LetztPos, Count: Integer;
begin
   ErstPos := Pos(':', DatenStr) - 1;
   LetztPos := Length(DatenStr) - 2;
   Count := LetztPos - ErstPos;
   ExtractLzPfad := Copy(DatenStr, Erstpos, Count);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
   MyStringList: TStringList;
   hFormIcon: THandle;

begin
  hFormIcon := LoadIcon(hInstance, 'FORMICON');
  SetClassLong(self.Handle, GCL_HICON, hFormIcon);
  SetClassLong(self.Handle, GCL_HICONSM, hFormIcon);
  Ti := 1;
  StartPfad := ExtractFilePath(ParamStr(0));
  LazarusPfad := StartPfad + 'lazarus\';
  LazarusPfad2 := StartPfad + 'lazarus';
  BackUpPfad := StartPfad + 'Backup\';
  fpcPfad := LazarusPfad + 'fpc\';
  If FileExists(LazarusPfad + 'environmentoptions.xml') = True Then
     begin
       MyStringList := TStringList.Create;
       MyStringList.LoadFromFile(LazarusPfad + 'environmentoptions.xml');
       MyStringList.SaveToFile(BackUpPfad + 'environmentoptions.xml.bak');
       MyStringList.Free;
     end;
  If FileExists(LazarusPfad + 'helpoptions.xml') = True Then
     begin
       MyStringList := TStringList.Create;
       MyStringList.LoadFromFile(LazarusPfad + 'helpoptions.xml');
       MyStringList.SaveToFile(BackUpPfad + 'helpoptions.xml.bak');
       MyStringList.Free;
     end;
  If FileExists(fpcPfad + '2.2.0\bin\i386-win32\fpc.cfg') = True Then
     begin
       MyStringList := TStringList.Create;
       MyStringList.LoadFromFile(fpcPfad + '2.2.0\bin\i386-win32\fpc.cfg');
       MyStringList.SaveToFile(BackUpPfad + 'fpc.cfg.bak');
       MyStringList.Free;
     end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
   Button1.Visible := False;
   Button2.Visible := False;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Ti := Ti + 1;
  If Ti =  2 Then Label1.Caption := 'Lazarus wird fr den Start vorbereitet!';
  if Ti =  6 Then Button1.Click;
  if Ti =  6 Then Label1.Caption := 'Lazarus wird jetzt gestartet';
  if Ti = 10 Then Button2.Click;
  if Ti = 11 Then Close;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  F: TextFile;
  S, S1, S2, S3, S4, S5, NS, LW, IStr, RS, ZPf, LzPfad: String;
  MyStringList: TStringList;
  I, IC, Z: Integer;

begin
  MyStringList := TStringList.Create;
  AssignFile(F, LazarusPfad + 'environmentoptions.xml');
  Reset     (F);
  while not eof(F) do
    begin
      Readln(F, S);
      If Pos('<LazarusDirectory Value="', S) > 0 Then
        begin
          LzPfad := ExtractLzPfad(S);
        end;
      NS := StringReplace(S, LzPfad, LazarusPfad2,[rfReplaceAll, rfIgnoreCase]);
      MyStringList.Add(NS);
    end;
  CloseFile(F);
  MyStringList.SaveToFile(LazarusPfad + 'environmentoptions.xml');
  MyStringList.Free;
  MyStringList := TStringList.Create;
  AssignFile(F, LazarusPfad + 'helpoptions.xml');
  Reset     (F);
  while not eof(f) do
     begin
       Readln(F, S);
       NS := StringReplace(S, LzPfad, LazarusPfad2,[rfReplaceAll, rfIgnoreCase]);
       MyStringList.Add(NS);
     end;
  CloseFile (F);
  MyStringList.SaveToFile(LazarusPfad + 'helpoptions.xml');
  MyStringList.Free;
  MyStringList := TStringList.Create;
  AssignFile(F, fpcPfad + '2.2.0\bin\i386-win32\fpc.cfg');
  Reset     (F);
  while not eof(F) do
    begin
      Readln(F, S);
      NS := StringReplace(S, LzPfad, LazarusPfad2,[rfReplaceAll, rfIgnoreCase]);
      MyStringList.Add(NS);
    end;
  CloseFile(F);
  MyStringList.SaveToFile(fpcPfad + '2.2.0\bin\i386-win32\fpc.cfg');
  MyStringList.Free;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  If FileExists(LazarusPfad + 'Lazarus.exe') Then
  shellexecute(handle,nil, PChar(LazarusPfad + 'Lazarus.exe'), '', PChar(LazarusPfad), 6);
end;


initialization
  {$I mainunit.lrs}

end.

